<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Chat</title>

    <link href="https://unpkg.com/tailwindcss@^1.0/dist/tailwind.min.css" rel="stylesheet">
</head>
<script>
    import { supabase }  from '$lib/supabaseClient'
	import { createEventDispatcher } from 'svelte';
    import { readable, get } from 'svelte/store'
    

    export let id
    export let title
    /**
	 * @type {any}
	 */
     export let content
    /**
	 * @type {string}
	 */
    

  
    async function addComment({target}){
        
        const formData = new FormData(target)
        // target.reset()
        const {data,error}= await supabase
            .from('comments')
            .insert({
                
                sender: formData.get('sender'),
                content: formData.get('comment'),
                post: id
            })
        document.getElementById("komen").value='';
    }

    const comments = readable(null, (set) =>{
        supabase
            .from('comments')
            .select('*')
            .filter('post','eq', id)
            .then(({error, data}) => set(data))
        
        // add subscription to supabase logic

        const subs = 
        supabase
            .channel('comments:post=eq.' + id)
            .on('postgres_changes',{ event: '*', schema: '*' }, (payload) => {
                if (payload.eventType === 'INSERT') {
                set([...get(comments), payload.new])
            }
            })
            
            .subscribe()

        return () => supabase.removeChannel(subs)
         
     
  
    })

let previousMessages = [];
</script>


<article style="padding:2 rem;">
    
        <div class="mx-11 my-5"> 
            <div class="chat-area flex-1 flex flex-col"> 
                <div class="flex-3"> 
                    <h2 class=" px-10 p-4 mb-8 border-b-2 border-gray-400">
                        <a href="/  "
                        class="px-2 py-1 text-blue-100 no-underline bg-blue-500 rounded-full hover:bg-blue-600 hover:text-white-200">Close</a> &nbsp;&nbsp;&nbsp;<b class="text-xl ml-48 px-48 ">Chatting with {title}</b></h2>
                </div>
                <div class="messages flex-1 overflow-auto">
                    <div class="message mb-4">
                        {#if $comments}
                            {#each $comments as {sender, content, created_at} }
                               
                            <div class="flex-1 px-10">
                                <div class="pl-4"><b class="text-gray-900 text-sm">{sender}</b></div>
                                    <div class="inline-block bg-gray-300 rounded-full p-2 px-3 text-gray-700">
                                        
                                        <span>{content}</span>
                                    </div>
                                    <div class="pl-4"><small class="text-gray-500">{created_at[11]}{created_at[12]}:{created_at[14]}{created_at[15]}</small></div>
                                    <br>
                                </div>
                            {:else}
                                No chats yet!
                            {/each}
                        {:else}
                            Loading..  
                        {/if}
                    </div>
                </div>
                
        
            <!-- <form on:submit|preventDefault={addComment}>
                <input placeholder="comment" name="comment"> <br>
                <input placeholder="who?" name="sender"><br>
                <button> Send Chat </button>
            </form>  -->
            </div>
            <form on:submit|preventDefault={addComment}>
            <div class="flex-2 pt-4 pb-10">
                <div class="write bg-white shadow flex rounded-lg">
                    <div class="flex-3 flex content-center items-center text-center p-4 pr-4">
                        <span class="block text-center text-gray-400 hover:text-gray-800">
                            <svg fill="none" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" stroke="currentColor" viewBox="0 0 24 24" class="h-6 w-6"><path d="M14.828 14.828a4 4 0 01-5.656 0M9 10h.01M15 10h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg>
                        </span>
                    </div>
                    <div class="flex-1">
                        
                        <div class="grid grid-rows-3 ">
                            <div class="row-start-1 row-span-3"><input required oninvalid="this.setCustomValidity('Enter ur name here')" oninput="this.setCustomValidity('')" name="sender" class="w-full block outline-none py-4 px-4 bg-gray-100" row=1 placeholder="Type ur name..." autofocus></div>
                            <div class="row-start-1 row-span-3 ..."><input id="komen" required oninvalid="this.setCustomValidity('Enter ur message here')" oninput="this.setCustomValidity('')" name="comment" class="w-full block outline-none py-4 px-4 bg-gray-100" row=3 placeholder="Type a message..." autofocus></div>
                          </div>
                    </div>
                    <div class="flex-2 w-32 p-2 flex content-center items-center">
                        <div class="flex-1 text-center">
                            <span class="text-gray-400 hover:text-gray-800">
                                <span class="inline-block align-text-bottom">
                                    <svg fill="none" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" stroke="currentColor" viewBox="0 0 24 24" class="w-6 h-6"><path d="M15.172 7l-6.586 6.586a2 2 0 102.828 2.828l6.414-6.586a4 4 0 00-5.656-5.656l-6.415 6.585a6 6 0 108.486 8.486L20.5 13"></path></svg>
                                </span>
                            </span>
                        </div>
                        <div class="flex-1">
                            <button class="bg-blue-400 w-10 h-10 rounded-full inline-block">
                                <span class="inline-block align-text-bottom">
                                    <svg fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" viewBox="0 0 24 24" class="w-4 h-4 text-white"><path d="M5 13l4 4L19 7"></path></svg>
                                </span>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            
            </form>
        </div>
    
    <!-- <form on:submit|preventDefault={addComment}>

        <input placeholder="who?" name="sender" ><br>
        <input  placeholder="comment" name="comment" > <br>
        <button >Send Chat </button>
    </form> -->
</article>